#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3000one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 3000"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire3000one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one30004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


 
                         
# -------------------------------------------------------------------------------------------------
# 3000
# -------------------------------------------------------------------------------------------------                                          
shot2one30004xi = {
                  1:'0x0y2999z',
                  2:'0x1986y2248z',
                  3:'0x90y2998z',
                  4:'1000x1377y2469z',
                  5:'1001x2150y1836z',
                  6:'1023x1845y2132z',
                  7:'102x1960y2268z',
                  8:'1048x2365y1518z',
                  9:'1052x2500y1279z',
                  10:'1056x1304y2486z',
                  11:'1103x2078y1860z',
                  12:'1106x1228y2503z',
                  13:'1106x1771y2153z',
                  14:'113x98y2996z',
                  15:'1151x1151y2519z',
                  16:'1164x2293y1544z',
                  17:'1175x2430y1307z',
                  18:'1185x1693y2174z',
                  19:'1191x1072y2536z',
                  20:'1201x2001y1883z',
                  21:'1225x992y2551z',
                  22:'1255x912y2567z',
                  23:'1259x1611y2194z',
                  24:'1274x2216y1569z',
                  25:'1293x1920y1907z',
                  26:'1295x2354y1333z',
                  27:'129x124y2994z',
                  28:'1327x1526y2215z',
                  29:'136x2683y1333z',
                  30:'1380x2133y1595z',
                  31:'1381x1834y1930z',
                  32:'1390x1439y2235z',
                  33:'13x358y2978z',
                  34:'1409x2271y1360z',
                  35:'143x153y2992z',
                  36:'1447x1349y2255z',
                  37:'1462x1745y1953z',
                  38:'1480x2044y1620z',
                  39:'1498x1257y2274z',
                  40:'1518x2183y1387z',
                  41:'1538x1651y1975z',
                  42:'1543x1163y2294z',
                  43:'154x183y2990z',
                  44:'1575x1951y1645z',
                  45:'1583x1068y2313z',
                  46:'1608x1555y1998z',
                  47:'1622x2090y1413z',
                  48:'162x215y2987z',
                  49:'1664x1854y1670z',
                  50:'1672x1455y2020z',
                  51:'167x248y2985z',
                  52:'168x316y2978z',
                  53:'169x282y2981z',
                  54:'170x364y3073z',
                  55:'1720x1991y1440z',
                  56:'172x2488y1666z',
                  57:'1730x1353y2042z',
                  58:'1747x1752y1695z',
                  59:'1782x1249y2064z',
                  60:'17x24y2999z',
                  61:'1811x1888y1466z',
                  62:'1823x1647y1720z',
                  63:'1894x1538y1744z',
                  64:'1897x1780y1492z',
                  65:'1957x1427y1769z',
                  66:'1976x1669y1518z',
                  67:'198x2265y1956z',
                  68:'202x1930y2287z',
                  69:'2049x1554y1544z',
                  70:'233x2775y1114z',
                  71:'275x2659y1360z',
                  72:'29x328y2981z',
                  73:'300x1894y2306z',
                  74:'300x2459y1691z',
                  75:'313x2232y1979z',
                  76:'31x50y2999z',
                  77:'377x2748y1142z',
                  78:'393x1853y2325z',
                  79:'3x30y2999z',
                  80:'3x60y2999z',
                  81:'411x2627y1387z',
                  82:'426x2193y2001z',
                  83:'426x2423y1716z',
                  84:'42x2510y1641z',
                  85:'42x296y2985z',
                  86:'43x78y2998z',
                  87:'484x1807y2344z',
                  88:'518x2713y1170z',
                  89:'52x107y2997z',
                  90:'52x264y2987z',
                  91:'535x2148y2024z',
                  92:'546x2589y1413z',
                  93:'548x2381y1740z',
                  94:'571x1757y2363z',
                  95:'58x232y2990z',
                  96:'59x137y2996z',
                  97:'61x200y2992z',
                  98:'62x168y2994z',
                  99:'641x2097y2046z',
                  100:'653x1702y2381z',
                  101:'656x2670y1197z',
                  102:'667x2332y1764z',
                  103:'677x2543y1440z',
                  104:'732x1644y2399z',
                  105:'743x2042y2068z',
                  106:'782x2277y1789z',
                  107:'792x2621y1225z',
                  108:'804x2490y1466z',
                  109:'806x1582y2417z',
                  110:'80x2291y1934z',
                  111:'841x1981y2089z',
                  112:'875x1517y2435z',
                  113:'88x2794y1087z',
                  114:'894x2216y1813z',
                  115:'924x2564y1252z',
                  116:'928x2431y1492z',
                  117:'934x1915y2111z',
                  118:'940x1448y2452z',
                  119:'94x73y2997z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire3000one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire3000one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3000ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3000ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3000ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3000ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3000ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE30004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one30004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3000ONE4XI - SUCCEEDED TO PUT SHOT2ONE30004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE30004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3000ONE4XI *** FAILED TO PUT SHOT2ONE30004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3000ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one30004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one30004xi</nack2put4xi>" 
             
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3000ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one30004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
        
    except:
        print(" (STEP 3C/33) OF FIRE3000ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3000ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3000one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
